package sun.rmi.log;

import sun.rmi.server.MarshalInputStream;
import java.io.InputStream;
import sun.rmi.server.MarshalOutputStream;
import java.io.OutputStream;

public abstract class LogHandler
{
    public LogHandler() {
    }
    
    public abstract Object initialSnapshot() throws Exception;
    
    public void snapshot(OutputStream out, Object obj) throws Exception {
        MarshalOutputStream marshalOutputStream = new MarshalOutputStream(out);
        marshalOutputStream.writeObject(obj);
        marshalOutputStream.flush();
    }
    
    public Object recover(InputStream in) throws Exception {
        return new MarshalInputStream(in).readObject();
    }
    
    public void writeUpdate(LogOutputStream out, Object obj) throws Exception {
        MarshalOutputStream marshalOutputStream = new MarshalOutputStream(out);
        marshalOutputStream.writeObject(obj);
        marshalOutputStream.flush();
    }
    
    public Object readUpdate(LogInputStream in, Object o) throws Exception {
        return this.applyUpdate(new MarshalInputStream(in).readObject(), o);
    }
    
    public abstract Object applyUpdate(Object p0, Object p1) throws Exception;
}
